#include <stdlib.h>
#include <string.h>
#include <stdio.h>
 
 // Note
 // Windows users can link with setargv.obj in the linker options which will automatically
 // expand any wild card arguments in the argv list
 // The argv lists all the strings in the parameter list.
 
 // Undefine this if not linked with setargv.obj.
#define SHOW_WINDOWS_SETARGV_HELP

char MakeOkFileName(char *szName);
void RemoveExt(char *szFile,char *szExt);
int has_char(char *sz,char c);
void printtop (FILE *fpout,int algorithm,char *name);
void printtop_high_res(FILE *fpout,int algorithm,char *name);

void RemoveLeadingAndTrailingWhiteSpace(char *sz);    
void printtop (FILE *fpout,int algorithm,char *name);
void printbottom (FILE * fpout);

#define CURRENT_POSITION 1

float  FreqTableCoarse[2][32] = {{0.5, 1, 2,  3,  4,  5,
                                   6,  7,  8,  9,  10, 11,
                                  12, 13, 14, 15, 16, 17,
                                  18, 19, 20, 21, 22, 23, 
                                  24, 25, 26, 27, 28, 29,
                                  30, 31},
                                 {1, 10, 100,  1000,  1,  10,
                                 100, 1000, 1, 10, 100, 1000,
                                  1, 10, 100, 1000, 1, 10,
                                 100, 1000, 1, 10, 100, 1000, 
                                  1, 10, 100, 1000, 1, 10,
                                  100, 1000}};
double   FreqTableFine[2][100] = {{1.00, 1.01, 1.02, 1.03, 1.04,
                                  1.05, 1.06, 1.07, 1.08, 1.09,
                                  1.10, 1.11, 1.12, 1.13, 1.14,
                                  1.15, 1.16, 1.17, 1.18, 1.19,
                                  1.20, 1.21, 1.22, 1.23, 1.24,
                                  1.25, 1.26, 1.27, 1.28, 1.29,
                                  1.30, 1.31, 1.32, 1.33, 1.34,
                                  1.35, 1.36, 1.37, 1.38, 1.39,
                                  1.40, 1.41, 1.42, 1.43, 1.44,
                                  1.45, 1.46, 1.47, 1.48, 1.49,
                                  1.50, 1.51, 1.52, 1.53, 1.54,
                                  1.55, 1.56, 1.57, 1.58, 1.59,
                                  1.60, 1.61, 1.62, 1.63, 1.64,
                                  1.65, 1.66, 1.67, 1.68, 1.69,
                                  1.70, 1.71, 1.72, 1.73, 1.74,
                                  1.75, 1.76, 1.77, 1.78, 1.79,
                                  1.80, 1.81, 1.82, 1.83, 1.84,
                                  1.85, 1.86, 1.87, 1.88, 1.89,
                                  1.90, 1.91, 1.92, 1.93, 1.94,
                                  1.95, 1.96, 1.97, 1.98, 1.99},
                                 {1.000, 1.023, 1.047, 1.072, 1.096,
                                  1.122, 1.148, 1.175, 1.202, 1.230,
                                  1.259, 1.288, 1.318, 1.349, 1.380,
                                  1.413, 1.445, 1.479, 1.514, 1.549,
                                  1.585, 1.622, 1.660, 1.698, 1.738,
                                  1.778, 1.820, 1.862, 1.905, 1.950,
                                  1.995, 2.042, 2.089, 2.138, 2.188,
                                  2.239, 2.291, 2.344, 2.399, 2.455,
                                  2.512, 2.570, 2.630, 2.692, 2.716,
                                  2.818, 2.884, 2.951, 3.020, 3.090,
                                  3.162, 3.236, 3.311, 3.388, 3.467,
                                  3.548, 3.631, 3.715, 3.802, 3.890,
                                  3.981, 4.074, 4.169, 4.266, 4.365,
                                  4.467, 4.571, 4.677, 4.786, 4.898,
                                  5.012, 5.129, 5.248, 5.370, 5.495,
                                  5.623, 5.754, 5.888, 6.026, 6.166,
                                  6.310, 6.457, 6.607, 6.761, 6.918,
                                  7.079, 7.244, 7.413, 7.586, 7.762,
                                  7.943, 8.128, 8.318, 8.511, 8.718,
                                  8.913, 9.120, 9.333, 9.550, 9.772}};

struct dx7_operator {
unsigned char OP_EG_R1;   
unsigned char OP_EG_R2;     
unsigned char OP_EG_R3;      
unsigned char OP_EG_R4;      
unsigned char OP_EG_L1;     
unsigned char OP_EG_L2;     
unsigned char OP_EG_L3;     
unsigned char OP_EG_L4;     
unsigned char LEV_SCL_BRK_PT; 
unsigned char SCL_LEFT_DEPTH;
unsigned char SCL_RGHT_DEPTH;
unsigned char SCL_LEFT_CURVE:2;
unsigned char SCL_RIGHT_CURVE:6;
unsigned char OSC_RATE_SCALE:3;
unsigned char OSC_DETUNE:5;
unsigned char AMP_MOD_SENS:2;
unsigned char KEY_VEL_SENS:6;
unsigned char OUTPUT_LEV; 
unsigned char OSC_MODE:1;
unsigned char FREQ_COARSE:7;
unsigned char FREQ_FINE;
} operator[6];

struct dx7_globals {
unsigned char PITCH_EG_R1;  
unsigned char PITCH_EG_R2;  
unsigned char PITCH_EG_R3;   
unsigned char PITCH_EG_R4;   
unsigned char PITCH_EG_L1;   
unsigned char PITCH_EG_L2;   
unsigned char PITCH_EG_L3;   
unsigned char PITCH_EG_L4;   
unsigned char ALGORITHM; 
unsigned char FEEDBACK:3;
unsigned char OSC_KEY_SYNC:5;
unsigned char LFO_SPEED;
unsigned char LFO_DELAY;     
unsigned char LF_PT_MOD_DEP; 
unsigned char LF_AM_MOD_DEP; 
unsigned char SYNC:1;
unsigned char WAVE:3;
unsigned char LF_PT_MOD_SNS:4;
unsigned char TRANSPOSE;
char NAME[10];
} global;

#ifndef MAX_PATH
 #define MAX_PATH 256
#endif

main( int argc, char *argv[ ])
{
 char extract_init_voice=0;
 char high_res=1;
 char add_algorithm_to_file_name=0;
 int i=0;
 int noutput_files=0;
 FILE *fpin,*fpout;
 char header[6];
 char out[MAX_PATH];
 int total, count=0,op=0;
 double frequency;
 char name[11];
 char szin[MAX_PATH];
 char replace_all=0;
 
 
 if(argc<2)
 {
  printf
   (
   "Usage:\n"
   "Dx72csd <dx7 file>\n"
   "Makes separate CSound instruments in the form of CSD files for each patch\n"
   "in a DX7\n"
#ifdef SHOW_WINDOWS_SETARGV_HELP
   "\n"
   "You can specify several files at once on the command line or use wild cards\n"
   "Ex:\n"
   "Dx72csd *.dx7 *.syx\n"
   "\n"
   "to to extract the instruments from all the dx7 and syx files in the current\n"
   "directory, or\n"
   "Dx72csd koto.dx7 bass.dx7\n"
   "\n"
   "to extract them from those two files\n"
   "\n"
   "Long file names recognised. File names with spaces need to be put in quotes:\n"
   "Dx72csd \"test file name with spaces.dx7\"\n"
   "\n"
   "flags: /W to overwrite old files automatically\n"
   "/A to add the algorithm to the output names (applies to files after it)\n"
   "/L for low resolution sine wave table - faster to render but lower quality,\n"
   "/S for super high res - requires several megabytes of tables.,\n"
   "Also has linear rather than cubic splines for the curve interpolations.\n"
   "/I to extract instruments called \"init voice\",\n"
   );
#endif
  printf
   ("Press return to continue....................................................\n");
  getchar();
  printf
   (
   "The csd file format is the one originally developed for CSoundAV and now\n"
   "standard as the CSound unified format.\n"
   "\n"
   "An extra <CsInstrumentToPlay> section has been added here,\n"
   "which shows typical parameters to use to call the instrument.\n"
   "This doesn't affect existing usage as programs will ignore the\n"
   "any unrecognised tags (in the same way that Web browsers ignore unrecognised\n"
   "tags).\n"
   "\n"
   "This new section can be used with the help of software to automatically build\n"
   "any number of single instruments into a larger orchestra (with the instruments\n"
   "in any desired pan positions), and auto generate scores for them. You can see\n"
   "how this works with Fractal Tune Smithy - the user just needs to select the\n"
   "instruments from a drop list and doesn't need to edit the code at all. See:\n"
   "http://www.tunesmithy.co.uk.\n"
   "You find the CSound section under File | CSound Opts in FTS\n"
   "\n"
   );
  printf
   ("Press return to continue....................................................\n");
  getchar();
  printf
   ("Mod of Jeff Harrington's DX72CSnd program.\n"
   "http://www.parnasse.com/dx72csnd.shtml\n"
   "\n"
   "Free for commercial or non commercial use.\n\n"
#ifdef SHOW_WINDOWS_SETARGV_HELP
   "You can run this program from the MSDOS prompt, or you can make a batch file\n"
   "to run it.\n"
   "\n"
   "To run it from a batch file, just create a file with extension .bat and\n"
   "place a single line in it:\n"
   "dx72csd *.dx7 *.syx\n"
   "\n"
   "Then to extract all the instruments in all the dx7 or syx files in a\n"
   "folder - just copy that file into the folder, then double click on it\n"
   "in your files explorer and they will all get extracted.\n"
#endif
   );
  printf
   ("Press return to exit......................................................\n"
    "..........................................................................\n");
  getchar();
 	exit(1);
	}
 printf("Files to do:\n");
 for(i=1;i<argc;i++)
  printf("\"%s\" ",argv[i]);
 printf("\n");
 for(i=1;i<argc;i++)
 {
  if(strcmpi(argv[i],"/W")==0
   ||strcmpi(argv[i],"-W")==0
   )
  {
   replace_all=1;
   continue;
  }
  if(strcmpi(argv[i],"/I")==0
   ||strcmpi(argv[i],"-i")==0
   )
  {
   extract_init_voice=1;
   continue;
  }
  if(strcmpi(argv[i],"/L")==0
   ||strcmpi(argv[i],"-L")==0
   )
  {
   high_res=0;
   continue;
  }
  if(strcmpi(argv[i],"/a")==0
   ||strcmpi(argv[i],"-a")==0
   )
  {
   add_algorithm_to_file_name=1;
   continue;
  }
#ifdef SHOW_WINDOWS_SETARGV_HELP
  if(has_char(argv[i],'*')||has_char(argv[i],'?'))
   // unexpanded wild card file names - if there are no files of that type,
   // then they get passed to the app unexpanded
   continue;
#endif
  strcpy(szin,argv[i]);
  if((fpin=fopen(szin,"rb"))==0)  
  {
   printf("Cannot open file %s\n",szin);
   sprintf(szin,"%s.syx",argv[i]);
   if((fpin=fopen(szin,"rb"))==0) 
   {
    sprintf(szin,"%s.dx7",argv[i]);
    if((fpin=fopen(szin,"rb"))==0) 
     exit(1);
   }
   printf("Added extension - extracting %s instead\n",szin);
	 }
  RemoveExt(szin,".dx7");
  RemoveExt(szin,".syx");
  fread(&header, 6L, 1, fpin);
  
  for (count=0;count<32;count++) {
   op=0;
   fread((&(operator[op])), 17L, 6, fpin);
   fread(&global, 16L, 1, fpin);
   fread(&name, 10, 1, fpin);
   name[10] = '\0';
   RemoveLeadingAndTrailingWhiteSpace(name);
   if(name[0]=='\0')
   {
    printf("***skipping patch %d - no name - probably not set***\n",count+1);
    continue;
   }
   if(!extract_init_voice)
   if(strcmpi(name,"init voice")==0)
   {
    printf("***skipping patch %d - called \"init voice\", so probably not set***\n",count+1);
    continue;
   }
   if(add_algorithm_to_file_name)
    sprintf(out,"DX7 %s - %02d %s Alg. %d.csd",szin,count+1,name,global.ALGORITHM+1);
   else
    sprintf(out,"DX7 %s - %02d %s.csd",szin,count+1,name);   
   MakeOkFileName(out);
   if(!replace_all)
   {
    FILE *fp=fopen(out,"r");
    if(fp)
     for(;;)
     {
      char c=0;
      printf("File %s already exists - replace?\n"
       "Answer Y(es), N(o) or A(ll)\n",out);
      c=(char)getchar();
      // remove any previously typed returns from input stream
      if(c=='\r'||c=='\n')
       c=(char)getchar();
      if(c=='\r'||c=='\n')
       c=(char)getchar();
      (char)getchar();// for the return after this character
      if(c=='a'||c=='A')
      {replace_all=1;break;}
      else
       if(c=='y'||c=='Y')
        break;
       else
        if(c=='n'||c=='N')
         exit(1);
     }
   }
   if ((fpout=fopen(out,"wt")) == 0) {
    printf("Couldn't open %s\n",out);
    exit(1);
   }
   if(add_algorithm_to_file_name)
   printf("Creating: %s\n",out);
   else
   printf("Creating: %s - Algorithm %d\n",out,global.ALGORITHM+1);
   fprintf
    (fpout,
    "<CsoundSynthesizer>\n"
    "\n"
    "<CsOptions>\n"
    "-W -o %s.wav\n"
    "</CsOptions>\n"
    "\n"
    "<CsInfo>\n"
    "%s converted from DX7 to CSound by Jeff Harrington's DX7 to CSound converter.\n"
    "\n"
    "See http://www.parnasse.com/dx72csnd.shtml -\n"
    "<CsInfo>\n"
    "\n"
    "<CsScore> \n"
    "\n"
    ,name
    ,name
    );
    if(high_res)
    printtop_high_res(fpout,global.ALGORITHM+1,name);
   else
    printtop(fpout,global.ALGORITHM+1,name);
   
   total = 11; 
   
   for (op=5;op>=0;op--) {
    total++;
    fprintf(fpout,"f%d   0    32    -2    %d    ",total,operator[op].OUTPUT_LEV);
    fprintf(fpout,"%d   ",operator[op].KEY_VEL_SENS);
    fprintf(fpout,"%d   ",operator[op].OP_EG_R1);   
    fprintf(fpout,"%d   ",operator[op].OP_EG_R2);     
    fprintf(fpout,"%d   ",operator[op].OP_EG_R3);      
    fprintf(fpout,"%d   \n",operator[op].OP_EG_R4);
    fprintf(fpout,"        %d   ",operator[op].OP_EG_L1);         
    fprintf(fpout,"%d   ",operator[op].OP_EG_L2);      
    fprintf(fpout,"%d   ",operator[op].OP_EG_L3);    
    fprintf(fpout,"%d   \n",operator[op].OP_EG_L4);    
    fprintf(fpout,"        %d   ",operator[op].AMP_MOD_SENS);
    fprintf(fpout,"%d   ",operator[op].OSC_MODE);
    frequency = FreqTableCoarse[operator[op].OSC_MODE][operator[op].FREQ_COARSE] * FreqTableFine[operator[op].OSC_MODE][operator[op].FREQ_FINE];
    fprintf(fpout,"%Lf   ",frequency);
    fprintf(fpout,"%d   \n",((int)operator[op].OSC_DETUNE)-7);
    fprintf(fpout,"        %d   \n",operator[op].OSC_RATE_SCALE);
   }
   fprintf(fpout,"t 0 20\n");
   fprintf(fpout,"i01 0 2.49 6.00 87 0 %d ",global.LFO_DELAY);
   fprintf(fpout,"%d %d \n",global.LF_PT_MOD_DEP,global.LFO_SPEED);
   fprintf(fpout," 12 13 14 15 16 17 2 4000\n");
   fprintf(fpout," 3 8 4 6 10 9 11 %d\n",global.FEEDBACK);
   fprintf(fpout,"; Algorithm = %d\n",global.ALGORITHM+1);
   fprintf(fpout,"; Patch name is %s\n\n",name);
   printbottom(fpout);
  
   fprintf
    (fpout,
    "</CsScore>\n"
    "\n"
    "<CsInstrumentToPlay>\n"
    "EXTRA  0 %d %d %d F12 F13 F14 F15 F16 F17 F2 4000 F3 F8 F4 F6 F10 F9 F11 %d\n"
    "\n"
    "i1 PCH  VEL\n"
    "\n"
    "</CsInstrumentToPlay>\n"
    "\n"
    ,global.LFO_DELAY,global.LF_PT_MOD_DEP,global.LFO_SPEED
    ,global.FEEDBACK
    );
   fprintf
    (fpout,
    "<CsPitchBendGlides>\n"
    "* ; Add an * here to show that it responds to pitch bend glides when auto converted into a midi instrument for CSoundAV (can be done in FTS)\n"
    "</CsPitchBendGlides>\n"
    "\n"
    "<CsInstruments>\n"
    "\n"
    );
   {
#define ONE_K 1024
    char szorc[ONE_K];
    FILE *fpin_orc=NULL;
    sprintf(szorc,"DX7%02d.orc",global.ALGORITHM+1);
    fpin_orc=fopen(szorc,"r");
    if(!fpin_orc)
    {printf("***Couldn't open %s for algorithm %d - skipping this one***\n",szorc,global.ALGORITHM+1);
    fclose(fpout);
    remove(out);
    continue;
    }
    for(;;)
    {
     char szLine[ONE_K];
     if(!fgets(szLine,ONE_K,fpin_orc))
      break;
     fprintf(fpout,"%s",szLine);
    }
    fclose(fpin_orc);
    fprintf
     (fpout,
     "</CsInstruments>\n"
     "\n"
     "</CsoundSynthesizer>\n"
     );
    if(ferror(fpout))
    {
     printf("File error writing to file \"%s\" - halting construction\n",out);
     break;
    }
    fclose(fpout);
    noutput_files++;
   }
   printf("Completed: %s\n",out);
   }
   if(ferror(fpin))
   {
    printf("File error reading from source file \"%s\" - halting construction\n",szin);
    break;
   }
   fclose(fpin);
   printf("All files completed for %s\n",argv[i]);
 }
 {
  int j=0;
  printf("%d Source file%s processed:\n",i-1,i-1==1?"":"s",i-1);
  for(j=1;j<i;j++)
  {
   printf("\"%s\" ",argv[j]);
   if(j%5==0)
    printf("\n");
  }
  printf("\n");
  printf("%d output files made\n",noutput_files);
  if(i==argc)
   printf("All files completed,\n");
  else
   printf("***Incomplete: %d source file%s processed out of %d***\n",i-1,i-1==1?"":"s",argc-1);
#ifdef _DEBUG // so you can see output in Debugger console window before it exits
  printf(" press return to exit\n");
  getchar();
 #else
  printf("\n");
#endif
 }
}


void printtop (FILE *fpout,int algorithm,char *name)
{
fprintf(fpout,";====================================================================;\n");
fprintf(fpout,";       Score header for DX7 alg %02d orc                                ;\n",algorithm);
fprintf(fpout,";                                                                    ;\n");
fprintf(fpout,";       (imitates the %s voice...sorta)                      ;\n",name);
fprintf(fpout,";                                                                    ;\n");
fprintf(fpout,";       DX72Csound by Jeff Harrington  idealord@dorsai.org           ;\n");
fprintf(fpout,";       After Models by Russell Pinkston                             ;\n");
fprintf(fpout,";  Thanks to T. Suzuki of Yamaha Corp. for the DX7 frequency tables  ;\n");       
fprintf(fpout,";====================================================================;\n");
fprintf(fpout,"f01     0       512     10      1\n");
fprintf(fpout,"; operator fpoutput level to amp scale function (data from Chowning/Bristow)\n");
fprintf(fpout,"f02     0       128     7       0       10      .003    10      .013\n");
fprintf(fpout,"        10      .031    10      .079    10      .188    10      .446\n");
fprintf(fpout,"        5       .690    5       1.068   5       1.639   5       2.512\n");
fprintf(fpout,"        5       3.894   5       6.029   5       9.263   4       13.119\n");
fprintf(fpout,"        29      13.119\n");
fprintf(fpout,"; rate scaling function\n");
fprintf(fpout,"f03     0       128     7       0       128     1\n");
fprintf(fpout,"; eg rate rise function for lvl change between 0 and 99 (data from Opcode)\n");
fprintf(fpout,"f04     0       128     -7      38      5       22.8    5       12      5\n");
fprintf(fpout,"        7.5     5       4.8     5       2.7     5       1.8     5       1.3\n");
fprintf(fpout,"        8       .737    3       .615    3       .505    3       .409    3\n");       
fprintf(fpout,"        .321    6       .080    6       .055    2       .032    3       .024\n");
fprintf(fpout,"        3       .018    3       .014    3       .011    3       .008    3\n");       
fprintf(fpout,"        .008    3       .007    3       .005    3       .003    32      .003\n");
fprintf(fpout,"; eg rate rise percentage function\n");
fprintf(fpout,"f05     0       128     -7      .00001  31      .00001  4       .02     5\n");
fprintf(fpout,"        .06     10      .14     10      .24     10      .35     10      .50\n");
fprintf(fpout,"        10      .70     5       .86     4       1.0     29      1.0\n");
fprintf(fpout,"; eg rate decay function for lvl change between 0 and 99\n");
fprintf(fpout,"f06     0       128     -7      318     4       181     5       115     5\n");
fprintf(fpout,"        63      5       39.7    5       20      5       11.2    5       7\n");       
fprintf(fpout,"        8       5.66    3       3.98    6       1.99    3       1.34    3\n");       
fprintf(fpout,"        .99     3       .71     5       .41     3       .15     3       .081\n");
fprintf(fpout,"        3       .068    3       .047    3       .037    3       .025    3\n");
fprintf(fpout,"        .02     3       .013    3       .008    36      .008\n");
fprintf(fpout,"; eg rate decay percentage function\n");
fprintf(fpout,"f07     0       128     -7      .00001  10      .25     10      .35     10\n");
fprintf(fpout,"        .43     10      .52     10      .59     10      .70     10      .77\n");
fprintf(fpout,"        10      .84     10      .92     9       1.0     29      1.0\n");
fprintf(fpout,"; eg level to peak deviation mapping function (index in radians = Index / 2PI)\n");
fprintf(fpout,"f08     0       128     -7      0       10      .000477 10      .002\n");
fprintf(fpout,"        10      .00493  10      .01257  10      .02992  10      .07098\n");
fprintf(fpout,"        5       .10981  5       .16997  5       .260855 5       .39979\n");
fprintf(fpout,"        5       .61974  5       .95954  5       1.47425 4       2.08795\n");
fprintf(fpout,"        29      2.08795\n");
fprintf(fpout,"; velocity to amp factor mapping function (rough guess)\n");
fprintf(fpout,"f09     0       129     9       .25     1       0\n");
fprintf(fpout,"; velocity sensitivity scaling function\n");
fprintf(fpout,"f10     0       8       -7      0       8       1\n");
fprintf(fpout,"; feedback scaling function\n");
fprintf(fpout,"f11     0       8       -7      0       8       7\n");            
}

void printtop_high_res (FILE *fpout,int algorithm,char *name)
{
fprintf(fpout,";====================================================================;\n");
fprintf(fpout,";       Score header for DX7 alg %02d orc                                ;\n",algorithm);
fprintf(fpout,";                                                                    ;\n");
fprintf(fpout,";       (imitates the %s voice...sorta)                      ;\n",name);
fprintf(fpout,";                                                                    ;\n");
fprintf(fpout,";       DX72Csound by Jeff Harrington  idealord@dorsai.org           ;\n");
fprintf(fpout,";       After Models by Russell Pinkston                             ;\n");
fprintf(fpout,";  Thanks to T. Suzuki of Yamaha Corp. for the DX7 frequency tables  ;\n");       
fprintf(fpout,";====================================================================;\n");
fprintf(fpout,";Higher res mod with exponential interpolations\n");            
fprintf(fpout,";Robert Walker (support@robertinventor.com)\n");            
fprintf(fpout,"f01     0       16384 10           1\n");
fprintf(fpout,"f02     0       128     5       1e-10       10      .003    10      .013\n");
fprintf(fpout,"        10      .031    10      .079    10      .188    10      .446\n");
fprintf(fpout,"        5       .690    5       1.068   5       1.639   5       2.512\n");
fprintf(fpout,"        5       3.894   5       6.029   5       9.263   4       13.119\n");
fprintf(fpout,"        29      13.119\n");
fprintf(fpout,"; rate scaling function\n");
fprintf(fpout,"f03     0       1024     7       0       128     1\n");
fprintf(fpout,"; eg rate rise function for lvl change between 0 and 99 (data from Opcode)\n");
fprintf(fpout,"f04     0       128     -5      38      5       22.8    5       12      5\n");
fprintf(fpout,"        7.5     5       4.8     5       2.7     5       1.8     5       1.3\n");
fprintf(fpout,"        8       .737    3       .615    3       .505    3       .409    3\n");       
fprintf(fpout,"        .321    6       .080    6       .055    2       .032    3       .024\n");
fprintf(fpout,"        3       .018    3       .014    3       .011    3       .008    3\n");       
fprintf(fpout,"        .008    3       .007    3       .005    3       .003    32      .003\n");
fprintf(fpout,"; eg rate rise percentage function\n");
fprintf(fpout,"f05     0       128     -5      0.0001  31      .00001  4       .02     5\n");
fprintf(fpout,"        .06     10      .14     10      .24     10      .35     10      .50\n");
fprintf(fpout,"        10      .70     5       .86     4       1.0     29      1.0\n");
fprintf(fpout,"; eg rate decay function for lvl change between 0 and 99\n");
fprintf(fpout,"f06     0       128     -5      318     4       181     5       115     5\n");
fprintf(fpout,"        63      5       39.7    5       20      5       11.2    5       7\n");       
fprintf(fpout,"        8       5.66    3       3.98    6       1.99    3       1.34    3\n");       
fprintf(fpout,"        .99     3       .71     5       .41     3       .15     3       .081\n");
fprintf(fpout,"        3       .068    3       .047    3       .037    3       .025    3\n");
fprintf(fpout,"        .02     3       .013    3       .008    36      .008\n");
fprintf(fpout,"; eg rate decay percentage function\n");
/**
Linear seems to work best so far with this one.
Some combinations give a high pitched hum after the decay for ortega13 01 Glass.
Problem is that the exponential interpolations which one would expect
to work best start with a concave  exponential in the first segment and result doesn't
look very like the expected shape.

Cubic splines look good in the first segment but are be wavy at the end rather 
than changing abruptly to a horizontal line. Cubic interpolation is wavy 
throughout the first section. Linear seems to work best But probably
just need to find some other way of interpolating 
it - looks like a slightly bumpy inverted exponential = RW
**/
fprintf(fpout,"; finishes with a high pitched hum.\n");
fprintf(fpout,"f07     0       128     -7     .00001  10      .25     10      .35     10\n");
fprintf(fpout,"        .43     10      .52     10      .59     10      .70     10      .77\n");
fprintf(fpout,"        10      .84     10      .92     9       1.0     29      1.0\n");
fprintf(fpout,"; eg level to peak deviation mapping function (index in radians = Index / 2PI)\n");
fprintf(fpout,"f08     0       128     -5     1e-10       10      .000477 10      .002\n");
fprintf(fpout,"        10      .00493  10      .01257  10      .02992  10      .07098\n");
fprintf(fpout,"        5       .10981  5       .16997  5       .260855 5       .39979\n");
fprintf(fpout,"        5       .61974  5       .95954  5       1.47425 4       2.08795\n");
fprintf(fpout,"        29      2.08795\n");
fprintf(fpout,"; velocity to amp factor mapping function (rough guess)\n");
fprintf(fpout,"f09     0       129     9       .25     1       0\n");
fprintf(fpout,"; velocity sensitivity scaling function\n");
fprintf(fpout,"f10     0       8       -7      0       8       1\n");
fprintf(fpout,"; feedback scaling function\n");
fprintf(fpout,"f11     0       8       -7      0       8       7\n");            
}

void printbottom (FILE * fpout)
{
fprintf(fpout,"i 1.1   1.00   2.54  6.07    87\n");
fprintf(fpout,"i 1.2   2.00   2.16  6.08    75\n");
fprintf(fpout,"i 1.3   2.49   2.20  7.03    90\n");
fprintf(fpout,"i 1.4   3.01   2.20  7.04    74\n");
fprintf(fpout,"i 1.5   3.50   2.18  7.11    90\n");
fprintf(fpout,"i 1     4.01   2.15  8.00    75\n");
fprintf(fpout,"i 1.1   4.24   2.13  8.07    69\n");
fprintf(fpout,"i 1.2   4.50   2.07  8.08    72\n");
fprintf(fpout,"i 1.3   4.72   2.09  9.03    90\n");
fprintf(fpout,"i 1.4   4.98   2.16  9.00    79\n");
fprintf(fpout,"f0         9                             ;allow for a 4-beat final decay.\n");
fprintf(fpout,"e\n");
}


void substrcpy(char *sz1,char *sz2)
{
 //version that is safe for copying a
 // string to a substring of itself
 // as the c documentation says not to
 // use strcpy in this way (though it works)
 int i=0;
 if(!sz1||!sz2)
  return;
 for(;;i++)
 {
  char c=sz1[i]=sz2[i];
  if(c=='\0')
   return;
 }
}

int is_space(char c)
{
 // because isspace treats some characters beyond 128 as spaces
 switch(c)
 {
  case '\r':     \
  case '\n':     \
  case ' ' :     \
  case '\v':     \
  case '\f':     \
  case '\t':
   return 1;
 }
 return 0;
}

void RemoveLeadingWhiteSpace(char *sz)    
{
 int i;
 if(!sz)
  return;
 for(i=0;;i++)
 {
  char c=sz[i];
  if(!is_space(c))
  {
   if(i>0)
    substrcpy(sz,&sz[i]);
   break;
  }
 }
}

void RemoveTrailingWhiteSpace(char *sz)    
{
 int i;
 /**dbg_tws++;**/
 if(!sz)
  return;
 for(i=strlen(sz)-1;i>=0;i--)
 {
  char c=sz[i];
  if(is_space(c))
   sz[i]='\0';
  else
   break;
 }
}

void RemoveLeadingAndTrailingWhiteSpace(char *sz)    
{
 RemoveLeadingWhiteSpace(sz);    
 RemoveTrailingWhiteSpace(sz);    
}

int find_char_from_end(char *sz,char c)
{
	int ipos;
	for(ipos=strlen(sz);ipos>0;ipos--)
		if(sz[ipos]==c)
			return ipos;
	return 0;
}

void RemoveExt(char *szFile,char *szExt)
{
 if(!szFile)
  return;
 {
  int istrlen=strlen(szFile);
  int ipos_ext=istrlen-strlen(szExt);
  if(ipos_ext>0)
  if(strcmpi(&szFile[ipos_ext],szExt)==0)
  {
   szFile[ipos_ext]='\0';
   return;
  }
  if(strcmpi(szExt,".*any")==0||strcmpi(szExt,"*any")==0)
  {
   int idot=find_char_from_end(szFile,'.');
   int ifolder=find_char_from_end(szFile,'\\');
   int ifolder2=find_char_from_end(szFile,'/');
   if(idot>ifolder)
   if(idot>ifolder2)
   if(szFile[idot]=='.')
    szFile[idot]='\0';
  }
 }
}


char MakeOkFileName(char *szName)
{
	int i;
	char return_value=0;
	for(i=0;szName[i]!='\0';i++)
	{
		char c=szName[i];
		switch(c)
		{
		case '|':
		case '\\':
		case '<':
		case '>':
		case '"':
		case '?':
		case '*':szName[i]=' ';return_value=1;break;
		case ':':szName[i]=',';return_value=1;break;
		case '/':szName[i]='o';return_value=1;break;
		}
	}
 RemoveLeadingAndTrailingWhiteSpace(szName);
	return return_value;
}

int has_char(char *sz,char c)
{
 int i=0;
 for(i=0;sz[i];i++)
  if(sz[i]==c)
   return 1;
 return 0;
}