// FTS_MFX.h : main header file for the FTS_MFX DLL
//

#if !defined(AFX_FTS_MFX_H__00EDAF29_0203_11D2_AFFF_00A0C90DA071__INCLUDED_)
#define AFX_FTS_MFX_H__00EDAF29_0203_11D2_AFFF_00A0C90DA071__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

// {1235DA46-81F8-11d6-9D43-444553540000}
const GUID CLSID_FTS_MFX = {
	0x1235da46,
	0x81f8,
	0x11d6,
	{ 0x9d, 0x43, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0 } 
};

// {1235DA47-81F8-11d6-9D43-444553540000}
const GUID CLSID_FTS_MFXPropPage = {
	0x1235da47,
	0x81f8,
	0x11d6,
	{ 0x9d, 0x43, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0 } 
};

/////////////////////////////////////////////////////////////////////////////
// Friendly name of component
static const char s_szFriendlyName[] = "Fractal Tune Smithy";
static const char s_szFriendlyNamePropPage[] = "Fractal Tune Smithy Property Page";

/////////////////////////////////////////////////////////////////////////////
extern long g_lComponents;	// Count of active components
extern long g_lServerLocks;	// Count of locks

/////////////////////////////////////////////////////////////////////////////
// CMidiFilter

class CFTS_MFX:	public IMfxEventFilter,
								public IPersistStream,
								public ISpecifyPropertyPages
{
public:
	// Ctors
	CFTS_MFX();
	virtual ~CFTS_MFX();

	// *** IUnknown methods ***
	// Handled in FTS_MFXGen.cpp
	STDMETHODIMP_(HRESULT)	QueryInterface( REFIID riid, void** ppv );
  	STDMETHODIMP_(ULONG)		AddRef();
	STDMETHODIMP_(ULONG)		Release();

	// *** IMfxEventFilter methods ***
	// You need to implement these methods when creating "Fractal Tune Smithy"
	// Note: Skeleton methods are provided in FTS_MFX.cpp.
	STDMETHODIMP_(HRESULT) Connect( IUnknown* pContext );
	STDMETHODIMP_(HRESULT) Disconnect();
	STDMETHODIMP_(HRESULT) OnStart( LONG lTime, IMfxEventQueue* pqOut );
	STDMETHODIMP_(HRESULT) OnLoop( LONG lTimeRestart, LONG lTimeStop, IMfxEventQueue* pqOut );
	STDMETHODIMP_(HRESULT) OnStop( LONG lTime, IMfxEventQueue* pqOut );
	STDMETHODIMP_(HRESULT) OnEvents( LONG lTimeFrom, LONG lTimeThru, IMfxEventQueue* pqIn, IMfxEventQueue* pqOut );
	STDMETHODIMP_(HRESULT) OnInput( IMfxDataQueue* pqIn, IMfxDataQueue* pqOut );

	// *** IPersistStream methods ***
	STDMETHODIMP_(HRESULT)	Load( IStream* pStm );
	STDMETHODIMP_(HRESULT)	Save( IStream* pStm, BOOL bClearDirty );
	STDMETHODIMP_(HRESULT)	GetSizeMax( ULARGE_INTEGER* pcbSize );
	/////////////////////////////////////////////////////////
	// Next two are handled in FTS_MFXGen.cpp
	STDMETHODIMP_(HRESULT)	GetClassID( CLSID* pClsid );
	STDMETHODIMP_(HRESULT)	IsDirty();

	// *** ISpecifyPropertyPages methods ***
	// Handled in FTS_MFXGen.cpp
	STDMETHODIMP_(HRESULT)	GetPages( CAUUID* pPages );

// Attributes
	// TODO:  Declare methods which deal with setting or retreiving values here.
	
// Implementation
private:
	IMfxTempoMap*			m_pTempoMap;
	IMfxInputPulse*			m_pInputPulse;
	// IMfxDataQueue*			m_pDataQueue;
	LONG					m_cRef;
	BOOL					m_bDirty;
	CRITICAL_SECTION		m_cs;		// critical section to guard properties
};


/////////////////////////////////////////////////////////////////////////////
// CFTS_MFXApp
// See FTS_MFXGen.cpp for the implementation of this class
// This class should need to be modified when creating your plugin
//

class CFTS_MFXApp : public CWinApp
{
public:
	CFTS_MFXApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFTS_MFXApp)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CFTS_MFXApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CFTS_MFXApp theApp;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FTS_MFX_H__00EDAF29_0203_11D2_AFFF_00A0C90DA071__INCLUDED_)
